// chabaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "chaba.h"
#include "chabaDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HDEVNOTIFY hdevnotify1;

BOOL DoRegisterDeviceInterface(HWND hWnd,
                          GUID InterfaceClassGuid,
                          HDEVNOTIFY* hDevNotify)
/*
Routine Description:
    Registers for notification of changes in the device interfaces for
    the specified interface class GUID. 

Parameters:
    InterfaceClassGuid - The interface class GUID for the device 
        interfaces. 

    hDevNotify - Receives the device notification handle. On failure, 
        this value is NULL.

Return Value:
    If the function succeeds, the return value is TRUE.

    If the function fails, the return value is FALSE.
*/
{
    DEV_BROADCAST_DEVICEINTERFACE NotificationFilter;
    DWORD Err;

    ZeroMemory(&NotificationFilter, sizeof(NotificationFilter));
    NotificationFilter.dbcc_size = sizeof(DEV_BROADCAST_DEVICEINTERFACE);
    NotificationFilter.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
    NotificationFilter.dbcc_classguid = InterfaceClassGuid;

    *hDevNotify = RegisterDeviceNotification(hWnd,
                                             &NotificationFilter,
                                             DEVICE_NOTIFY_WINDOW_HANDLE
    //DEVICE_NOTIFY_ALL_INTERFACE_CLASSES
    //DEVICE_NOTIFY_SERVICE_HANDLE
    );

    if (!*hDevNotify)
    {
        Err = GetLastError();
        //printf("RegisterDeviceNotification failed: %lx.\n", Err);
        return FALSE;
    }

    return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChabaDlg dialog

CChabaDlg::CChabaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChabaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChabaDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChabaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChabaDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChabaDlg, CDialog)
	//{{AFX_MSG_MAP(CChabaDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChabaDlg message handlers

BOOL CChabaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//USBǰҪעһUSBϢ
	GUID tmpGuid;
    LONG tmpdata = 0;
    BOOL bReturn;
    //{a5dcbf10-6530-11d2-901f-00c04fb951ed} usb guid
    tmpGuid.Data1 = 0xa5dcbf10;
    tmpGuid.Data2 = 0x6530;
    tmpGuid.Data3 = 0x11d2;
    tmpGuid.Data4[0] = 0x90;
    tmpGuid.Data4[1] = 0x1f;
    tmpGuid.Data4[2] = 0;
    tmpGuid.Data4[3] = 0xc0;
    tmpGuid.Data4[4] = 0x4f;
    tmpGuid.Data4[5] = 0xb9;
    tmpGuid.Data4[6] = 0x51;
    tmpGuid.Data4[7] = 0xed;

	
    bReturn = DoRegisterDeviceInterface(this->GetSafeHwnd(),
                                        tmpGuid,
                                        &hdevnotify1);
    if (bReturn != TRUE)
		AfxMessageBox("Register USB error");
    else
    {
		//AfxMessageBox("Register Success!");
    }
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChabaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChabaDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChabaDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//DefWindowProcwindowsϢĺ
LRESULT CChabaDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	CString strError = "";
	CString strUSBInfo = "";
	int j = 0;

	switch (message)
    {
		case WM_DEVICECHANGE:
			//char szMsg[256] = {0};


            PDEV_BROADCAST_DEVICEINTERFACE pdbch = (PDEV_BROADCAST_DEVICEINTERFACE)lParam;
            switch (wParam)
            {
				case DBT_DEVICEARRIVAL:
					if (pdbch != NULL &&
						pdbch->dbcc_devicetype == DBT_DEVTYP_DEVICEINTERFACE)
					{
						//sprintf(szMsg, "%s  Insert ", pdbch->dbcc_name);  
						//MessageBox(szMsg, "WM_DEVICECHANGE", MB_OK);
						
						strUSBInfo.Empty();
						strUSBInfo.Format("%s",pdbch->dbcc_name);
					}

					//ET199USBעϢУVIDΪ096ePIDΪ0304
					if((strUSBInfo.Find("096e") >= 0) && (strUSBInfo.Find("0304") >= 0))
					{
						//MessageBox(strUSBInfo);
						MessageBox("ET199 Insert");

					}
			

					break;

				case DBT_DEVICEREMOVECOMPLETE:
                // See if a CD-ROM was removed from a drive.
					if (pdbch != NULL &&
						pdbch->dbcc_devicetype == DBT_DEVTYP_DEVICEINTERFACE)
					{
						//sprintf(szMsg, "%s  Remove ", pdbch->dbcc_name);  
						//MessageBox(szMsg, "WM_DEVICECHANGE", MB_OK);
						
						strUSBInfo.Empty();
						strUSBInfo.Format("%s",pdbch->dbcc_name);
					}

					if((strUSBInfo.Find("096e") >= 0) && (strUSBInfo.Find("0304") >= 0))
					{
						//MessageBox(strUSBInfo);
						MessageBox("ET199 Remove");
					}
							

					break;

				case DBT_DEVNODES_CHANGED:
					if (pdbch != NULL &&
						pdbch->dbcc_devicetype == DBT_DEVTYP_DEVICEINTERFACE)
					{
						//sprintf(szMsg, "%s  Change ", pdbch->dbcc_name);  
						//MessageBox(szMsg, "WM_DEVICECHANGE", MB_OK);
					}
					break;
            }
	}
	
	return CDialog::DefWindowProc(message, wParam, lParam);
}
